'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _kendoUiCoreJsKendoDropdownlistJs = require('kendo-ui-core/js/kendo.dropdownlist.js');

var _kendoUiCoreJsKendoDropdownlistJs2 = _interopRequireDefault(_kendoUiCoreJsKendoDropdownlistJs);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _deepDiff = require('deep-diff');

var _deepDiff2 = _interopRequireDefault(_deepDiff);

var KendoDropDownList = _react2['default'].createClass({
	displayName: 'KendoDropDownList',

	componentDidMount: function componentDidMount() {
		//comonent is in the DOM, so do stuff to it
		//store reference to:
		//1. element node widget is invoked on
		//2. element node widget, wrapped with jQuery
		//3. instance of widget
		var elementNode, $elementNode, widgetInstance;
		this.elementNode = elementNode = _reactDom2['default'].findDOMNode(this);
		this.$elementNode = $elementNode = (0, _jquery2['default'])(elementNode);

		//instantiate the Kendo UI widget from props or one prop called options
		$elementNode.kendoDropDownList(this.props.options);

		//saved instance reference now that it is created
		this.widgetInstance = widgetInstance = $elementNode.getKendoDropDownList();

		//if props are avaliable for events, triggers, unbind events, or methods make it happen
		this.props.events ? this.bindEventsToKendoWidget(this.props.events) : null;
		this.props.methods ? this.callKendoWidgetMethods(this.props.methods) : null;
		this.props.triggerEvents ? this.triggerKendoWidgetEvents(this.props.triggerEvents) : null;
		this.props.unbindEvents ? this.unbindEventsToKendoWidget(this.props.unbindEvents) : null;
	},
	triggerKendoWidgetEvents: function triggerKendoWidgetEvents(events) {
		events.forEach(function (event) {
			this.widgetInstance.trigger(event);
		}, this);
	},
	bindEventsToKendoWidget: function bindEventsToKendoWidget(events) {
		Object.keys(events).forEach(function (event) {
			this.widgetInstance.bind(event, events[event]);
		}, this);
	},
	unbindEventsToKendoWidget: function unbindEventsToKendoWidget(events) {
		events.forEach(function (event) {
			this.widgetInstance.unbind(event);
		}, this);
	},
	callKendoWidgetMethods: function callKendoWidgetMethods(methods) {
		Object.keys(methods).forEach(function (method) {
			var _widgetInstance;

			(_widgetInstance = this.widgetInstance)[method].apply(_widgetInstance, _toConsumableArray(methods[method]));
		}, this);
	},
	//not called on inital render, but whenever parent state changes this is called
	componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
		//have too, because these are functions, for now, thinking about stringing them and comparing
		if (nextProps.events) {
			this.bindEventsToKendoWidget(nextProps.events);
		}

		if (this.widgetInstance.setOptions) {
			if (nextProps.options) {
				this.widgetInstance.setOptions(nextProps.options);
			}
		}

		if (nextProps.methods) {
			if ((0, _deepDiff2['default'])(nextProps.methods, this.props.methods)) {
				this.callKendoWidgetMethods(nextProps.methods);
			}
		}

		if (nextProps.unbindEvents) {
			if ((0, _deepDiff2['default'])(nextProps.unbindEvents, this.props.unbindEvents)) {
				this.unbindEventsToKendoWidget(nextProps.unbindEvents);
			}
		}

		if (nextProps.triggerEvents) {
			if ((0, _deepDiff2['default'])(nextProps.triggerEvents, this.props.triggerEvents)) {
				this.triggerKendoWidgetEvents(nextProps.triggerEvents);
			}
		}
	},
	shouldComponentUpdate: function shouldComponentUpdate() {
		//doing this so Kendo UI widget is only ever create once
		//then, when a component above this one renders, it will send new props
		//that will update the kendo ui widget
		return false;
	},
	componentWillUnmount: function componentWillUnmount() {
		(0, _jquery2['default'])(_reactDom2['default'].findDOMNode(this)).getKendoDropDownList().destroy();
	},
	render: function render() {
		return this.props.children ? this.props.children : _react2['default'].createElement('div', null);
	}
});

exports['default'] = KendoDropDownList;
module.exports = exports['default'];